import weakref

import sip

from PyQt5.QtCore import QObject
from PyQt5.QtGui import QCursor
from PyQt5.QtWidgets import QMenu, QApplication, QPushButton


class Child:
    def __init__(self, parent):
        super().__init__()
        self._menu = QMenu()
        self._menu.addAction('test')
        self._parent = parent

    def exec(self):
        self._menu.exec_(QCursor.pos())


class Parent:
    def __init__(self):
        self._child = Child(self)

    def exec(self):
        self._child.exec()

    def subscribe(self, callback):
        self._child._menu.destroyed[QObject].connect(callback)


def on_push_btn():
    prnt = Parent()
    prnt.subscribe(on_qobject_destroy)
    weak_refs.append(weakref.ref(prnt, on_weak_ref_dead))
    prnt.exec()


weak_refs = list()


def on_weak_ref_dead(weak):
    print('Weak ref', weak, 'is dead')


def on_qobject_destroy(obj):
    print('QObject is being destroyed,', obj)


if __name__ == '__main__':
    qapp = QApplication([])
    #sip.setdestroyonexit(True)

    btn = QPushButton('Push me')
    btn.clicked.connect(on_push_btn)
    btn.show()

    qapp.exec()
